//THIS CODE HAS NOT BEEN COMPILED AND IS UNTESTED
// !!!!!!!! THIS IS TEST CODE ONLY !!!!!!!!
// !!!!!!!!  USE AT YOUR OWN RISK  !!!!!!!!
//============================================================================
// 632 / 634 SPI Mode Host Template
// Copyright 2002, Crystalfontz America, Inc. Written by Brent A. Crosby
// www.crystalfontz.com, brent@crystalfontz.com
//============================================================================
#define BUFFER_SIZE 20
unsigned char
  transmit_buffer[BUFFER_SIZE];
unsigned char
  head_index;
volatile unsigned char
  tail_index;
unsigned char
  transmit_register;
unsigned char
  SPI_State;
#define SPIS_IDLE       0
#define SPIS_CLK_LOW_0  1
#define SPIS_CLK_HIGH_0 2
#define SPIS_CLK_LOW_1  3
#define SPIS_CLK_HIGH_1 4
#define SPIS_CLK_LOW_2  5
#define SPIS_CLK_HIGH_2 6
#define SPIS_CLK_LOW_3  7
#define SPIS_CLK_HIGH_3 8
#define SPIS_CLK_LOW_4  9
#define SPIS_CLK_HIGH_4 10
#define SPIS_CLK_LOW_5  11
#define SPIS_CLK_HIGH_5 12
#define SPIS_CLK_LOW_6  13
#define SPIS_CLK_HIGH_6 14
#define SPIS_CLK_LOW_7  15
#define SPIS_CLK_HIGH_7 16
#define SPIS_CS_HIGH    17
//============================================================================
//Macros to control port pins (you define these)
#define SPI_CS_HIGH . . . 
#define SPI_CS_LOW . . . 
#define SPI_CLOCK_HIGH . . . 
#define SPI_CLOCK_LOW . . . 
#define SPI_DATA_HIGH . . . 
#define SPI_DATA_LOW . . . 
//============================================================================
void initialize(void)
  {
  //Clear buffer
  head_index=tail_index=0;

  //Reset state machine
  SPI_State=SPIS_IDLE;

  //Make sure the port pins are idle
  SPI_CS_HIGH;
  SPI_CLOCK_HIGH;
  SPI_DATA_LOW;

  //Initialize ISR to hit SPI_Interrupt every 55uS
  (processor dependent)
  }
//============================================================================
void SendByte(unsigned char Byte_To_Send)
  {
  //Wait here until there is room in the output buffer.  Increment a
  //pointer and wrap it if needed.
  unsigned char
    LocalTransmitBufferHead;
  LocalTransmitBufferHead=head_index;
  LocalTransmitBufferHead++;
  if(BUFFER_SIZE<=LocalTransmitBufferHead)
    LocalTransmitBufferHead=0;
  while(LocalTransmitBufferHead==tail_index);
  //Now there is room in the output buffer. Put the ubyte in the transmit buffer.
  transmit_buffer[head_index]=Byte_To_Send;
  //Update the real pointer with the incremented & wrapped pointer.
  head_index=LocalTransmitBufferHead;
  }
//============================================================================
//This code is written as "bulky and fast"
//Convert the "switch" to a processor specific asm jump table to
//get "small and fast" :)
//You could also use another variable (bit counter or bit mask) to make
//the ISR smaller but slightly longer execution time by condensing
//all of the data bits into one state. The way it is, it looks bulky
//but most of the cases should compile to only a few instructions.
interrupt void SPI_Interrupt(void)
  {
  switch(SPI_State)
    {
    case SPIS_IDLE:
      //See if there is a byte to send.
      if(head_index!=tail_index)
        {
        //There is some data available. Drop the Chip select.
        SPI_CS_LOW;
        //Put the next byte in the transmit register.
        transmit_register=transmit_buffer[tail_index];
        //Move the tail_index.
        tail_index++;
        //Handle wrapping
        if(BUFFER_SIZE<=tail_index)
          tail_index=0;
        //Put bit 0 on the data line
        if(transmit_register&0x80)
          SPI_DATA_HIGH;
        else
          SPI_DATA_LOW;
        //Next state is dropping the clock for bit 0.
        SPI_State=SPIS_CLK_LOW_0;
        }
      break; //"return" may be faster than a "break" 
    case SPIS_CLK_LOW_0:
      //The data is already on the data line. Time to drop the
      //clock line.
      SPI_CLOCK_LOW;
      SPI_State=SPIS_CLK_HIGH_0;
      break;
    case SPIS_CLK_HIGH_0:
      //Bring the clock back up, and put the next bit
      //on the data line.
      SPI_CLOCK_HIGH;
      if(transmit_register&0x40)
        SPI_DATA_HIGH;
      else
        SPI_DATA_LOW;
      SPI_State=SPIS_CLK_LOW_1;
      break;
    case SPIS_CLK_LOW_1:
      //The data is already on the data line. Time to drop the
      //clock line.
      SPI_CLOCK_LOW;
      SPI_State=SPIS_CLK_HIGH_1;
      break;
    case SPIS_CLK_HIGH_1:
      //Bring the clock back up, and put the next bit
      //on the data line.
      SPI_CLOCK_HIGH;
      if(transmit_register&0x20)
        SPI_DATA_HIGH;
      else
        SPI_DATA_LOW;
      SPI_State=SPIS_CLK_LOW_2;
      break;
    case SPIS_CLK_LOW_2:
      //The data is already on the data line. Time to drop the
      //clock line.
      SPI_CLOCK_LOW;
      SPI_State=SPIS_CLK_HIGH_2;
      break;
    case SPIS_CLK_HIGH_2:
      //Bring the clock back up, and put the next bit
      //on the data line.
      SPI_CLOCK_HIGH;
      if(transmit_register&0x10)
        SPI_DATA_HIGH;
      else
        SPI_DATA_LOW;
      SPI_State=SPIS_CLK_LOW_3;
      break;
    case SPIS_CLK_LOW_3:
      //The data is already on the data line. Time to drop the
      //clock line.
      SPI_CLOCK_LOW;
      SPI_State=SPIS_CLK_HIGH_3;
      break;
    case SPIS_CLK_HIGH_3:
      //Bring the clock back up, and put the next bit
      //on the data line.
      SPI_CLOCK_HIGH;
      if(transmit_register&0x08)
        SPI_DATA_HIGH;
      else
        SPI_DATA_LOW;
      SPI_State=SPIS_CLK_LOW_4;
      break;
    case SPIS_CLK_LOW_4:
      //The data is already on the data line. Time to drop the
      //clock line.
      SPI_CLOCK_LOW;
      SPI_State=SPIS_CLK_HIGH_4;
      break;
    case SPIS_CLK_HIGH_4:
      //Bring the clock back up, and put the next bit
      //on the data line.
      SPI_CLOCK_HIGH;
      if(transmit_register&0x04)
        SPI_DATA_HIGH;
      else
        SPI_DATA_LOW;
      SPI_State=SPIS_CLK_LOW_5;
      break;
    case SPIS_CLK_LOW_5:
      //The data is already on the data line. Time to drop the
      //clock line.
      SPI_CLOCK_LOW;
      SPI_State=SPIS_CLK_HIGH_5;
      break;
    case SPIS_CLK_HIGH_5:
      //Bring the clock back up, and put the next bit
      //on the data line.
      SPI_CLOCK_HIGH;
      if(transmit_register&0x02)
        SPI_DATA_HIGH;
      else
        SPI_DATA_LOW;
      SPI_State=SPIS_CLK_LOW_6;
      break;
    case SPIS_CLK_LOW_6:
      //The data is already on the data line. Time to drop the
      //clock line.
      SPI_CLOCK_LOW;
      SPI_State=SPIS_CLK_HIGH_6;
      break;
    case SPIS_CLK_HIGH_6:
      //Bring the clock back up, and put the next bit
      //on the data line.
      SPI_CLOCK_HIGH;
      if(transmit_register&0x01)
        SPI_DATA_HIGH;
      else
        SPI_DATA_LOW;
      SPI_State=SPIS_CLK_LOW_71;
      break;
    case SPIS_CLK_LOW_7:
      //The data is already on the data line. Time to drop the
      //clock line.
      SPI_CLOCK_LOW;
      SPI_State=SPIS_CLK_HIGH_7;
      break;
    case SPIS_CLK_HIGH_7:
      //Bring the clock back up. No need to change the data
      //but idle it low for kicks.
      SPI_CLOCK_HIGH;
      SPI_DATA_LOW;
      SPI_State=SPIS_CS_HIGH;
      break;
    case SPIS_CLK_HIGH_7:
      //Idle the CS.
      SPI_CS_HIGH;
      SPI_State=SPIS_IDLE;
      break;
    }
  }
//============================================================================
